/*
The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

Alternatively, the contents of this file may be used under the
terms of the GNU General Public License Version 2 or later (the
"GPL"), in which case the provisions of the GPL are applicable 
instead of those above. 

Copyright (C) 2003
Vasa Maximov
mcv@mozdev.org
vmaximov@strana.ru
*/

listsrc = window.arguments[0];
NeedText = window.arguments[1];
var prmtbox, plbl;
window.opener.top.cancel = true;

function listloader(){
	window.setTimeout('MakeLists();', 0);
}

function MakeLists(){
try{
  for (i in listsrc){
    //if value="[:prompt]" build textboxs and append ONLY LAST of them to doc in the end of cycle
    if (String(listsrc[i].value).search(/\[:prompt\]/gi)!=-1){
    	plbl = document.createElement('label');
    	if (listsrc[i].label) {plbl.setAttribute("value", listsrc[i].label+":")}else{plbl.setAttribute("value", listsrc[i].name+":")};
		  prmtbox = document.createElement('textbox');
		  prmtbox.setAttribute("id", "prmtbox");
    }
    //if input has list of values
    if (listsrc[i].list){
    	lbl = document.createElement('label');
    	if (listsrc[i].grouptitle) {lbl.setAttribute("value", listsrc[i].grouptitle+":")}else{lbl.setAttribute("value", listsrc[i].name+":")};
    	lst = document.createElement('menulist');
      lst.setAttribute("id", i);
      pp = document.createElement('menupopup');
      item = document.createElement('menuitem');
      if (listsrc[i].label) {item.setAttribute("label", listsrc[i].label)}else{item.setAttribute("label", listsrc[i].value)};
      item.setAttribute("value", listsrc[i].value);
      pp.appendChild(item);
  
    	for (v in listsrc[i].list){
		    //Check for [:prompt] here
		    if (String(listsrc[i].list[v].value).search(/\[:prompt\]/gi)!=-1){
		    	plbl = document.createElement('label');
		    	if (listsrc[i].list[v].label) {plbl.setAttribute("value", listsrc[i].list[v].label+":")}else{plbl.setAttribute("value", listsrc[i].list[v].label+":")};
				  prmtbox = document.createElement("textbox");
				  prmtbox.setAttribute("id", "prmtbox");
		    }
        item = document.createElement('menuitem');
        if (listsrc[i].list[v].label){item.setAttribute("label", listsrc[i].list[v].label)}else{item.setAttribute("label", listsrc[i].list[v].value)};
        item.setAttribute("value", listsrc[i].list[v].value);
        pp.appendChild(item);
    	}
      lst.appendChild(pp);
      document.documentElement.appendChild(lbl);
      document.documentElement.appendChild(lst);
    }
  }
  if (plbl) document.documentElement.appendChild(plbl);
  if (prmtbox) document.documentElement.appendChild(prmtbox);

  if (NeedText){
	  txtlbl = document.createElement('label');
	  txtlbl.setAttribute("value", "No selected text found:");
	  txtbox = document.createElement('textbox');
	  txtbox.setAttribute("id", "seltxt");
	  document.documentElement.appendChild(txtlbl);
	  document.documentElement.appendChild(txtbox);
	}
	window.sizeToContent();
}catch(er){cqerr(er, "MakeLists sub")}
}

function onOk(){
	window.opener.top.cancel = false;
	act = "";
	amp = "";
  for (i in listsrc){
    if (listsrc[i].list){
			lst = document.getElementById(i);
			act += amp + listsrc[i].name + "=" + lst.selectedItem.value;
    }else{
    	act += amp + listsrc[i].name + "=" + listsrc[i].value;
    }
  amp = "&";
  }
	window.opener.top.act = act;
  if (NeedText) window.opener.top.PageSelection = document.getElementById("seltxt").value;
	if (prmtbox) window.opener.top.PromptText = prmtbox.value;
}

