/*
The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

Alternatively, the contents of this file may be used under the
terms of the GNU General Public License Version 2 or later (the
"GPL"), in which case the provisions of the GPL are applicable 
instead of those above. 

Copyright (C) 2003
Vasa Maximov
mcv@mozdev.org
vmaximov@strana.ru
*/

var PlugsPath = "";
var ReadOnlyCqr = "";
var delim = "";
var AllFiles = [];

function loader(){
	PlugsPath = window.opener.top.PlugsDirBox.value;
	PlugExt = window.arguments[0];
	delim = window.opener.top.delim;
	window.setTimeout('LoadEmAll();', 0);
}

function setstatus(cnt){
	var pStatus  = document.getElementById('parserstatus');	
	pStatus.value = cnt;
}

function LoadEmAll(){
try{
  if (!PlugsPath) return;
  exploredir(PlugsPath);
  var cnt = 0;
	var item = new window.opener.top.ProtoEntry();
  for (file in AllFiles){
		f = AllFiles[file];
		var ExtRE = new RegExp("\."+PlugExt,"i");
		var fext = f.substr(f.length - 4, f.length);
		if (ExtRE.test(fext)){
		window.opener.top.repEntryHash._AddEntryObj(window.opener.top.ReadPluginData(f), "");
		}
  }
}catch(er){cqerr(er, "LoadEmAll sub")}
window.opener.top.initRepTree(window.opener.top.repEntryList, window.opener.top.repEntryHash)
window.close()
}


function exploredir(start){
  var items = cqReadDir(start);
  items.QueryInterface(Components.interfaces.nsISimpleEnumerator);
  while (items.hasMoreElements()) {
    var i = items.getNext();
    i.QueryInterface(Components.interfaces.nsIFile);
    if (i.isDirectory()){
      exploredir(start+delim+i.leafName);
    }else{
      AllFiles[AllFiles.length] = start+delim+i.leafName;
    }
  }
}


function cqReadDir(dirname) {
    var dir = Components.classes["@mozilla.org/file/local;1"].
               createInstance(Components.interfaces.nsILocalFile);
    dir.initWithPath(dirname);
    if (dir.isDirectory()) {
        return dir.directoryEntries;
    } else {
        cqerr(null, "Error reading directory:\n" + dirname);
    }
}

function initRepTree(list, srcHash){
  var cnt = 0;
  while (list.hasChildNodes()) {list.removeChild(list.lastChild)}
  var ondk;
  var onsel;
  var item;
  var node;
  var celldata;
  var entries = srcHash._Items();
	var treecols = document.createElement('treecols');
	var treecol = document.createElement('treecol');
  treecol.setAttribute("label", "Found plugins");
  treecol.setAttribute("flex", "1");
  treecol.setAttribute("id", "www");
	treecols.appendChild(treecol);
	list.appendChild(treecols);
	var tch = document.createElement('treechildren');
	//list.appendChild(tch);

  for (i in entries){
    //window.setTimeout('setstatus("Building tree: '+cnt+' childes so far")',7000);
  	//cnt++;
  	ondk='if (isValidLeftClick(event,"listitem")) CopyEntry(repEntryHash, '+entries[i].eId+', EntryHash, EntryList);';
  	onsel = 'onSelectRep('+entries[i].eId+')';
    item = document.createElement('treeitem');
    item.setAttribute('id', entries[i].eId);
    row = document.createElement('treerow');

    row.setAttribute('id', entries[i].eId);
    row.setAttribute('ondblclick', ondk);
    //row.setAttribute('allowevents', true);
		
    celldata = document.createElement('treecell');
    celldata.setAttribute('label', entries[i].Title);
    celldata.setAttribute('onselect', onsel);
    row.appendChild(celldata);
    
    //if (isValidLeftClick(event,"listitem")) 
    item.appendChild(row);
    tch.appendChild(item);
    //list.insertBefore(item, prevItem);
  }
  list.appendChild(tch);
}
